import { aws_lambda as lambda } from 'aws-cdk-lib';
import { Construct } from 'constructs';
import { BaseDependencyPackager, DependencyPackagerProps, LayerProps } from './base';
/**
 * Packager for creating Lambda layers for Ruby dependencies in AWS. Nothing is done locally so this doesn't require Docker, doesn't download any packages and doesn't upload huge files to S3.
 */
export declare class RubyDependencyPackager extends BaseDependencyPackager {
    private static runtimeVersion;
    constructor(scope: Construct, id: string, props?: DependencyPackagerProps);
    /**
     * Create a layer for dependencies defined in Gemfile and (optionally) Gemfile.lock and installed with Bundler.
     */
    layerFromBundler(id: string, path: string, props?: LayerProps): lambda.LayerVersion;
}
